// Copyright (C) 2001 Jean-Marc Valin

#ifndef GUINODEPARAMETERS_H
#define GUINODEPARAMETERS_H

#include <gnome.h>
#include <string>
#include <vector>
#include <tree.h>
#include "UINodeParameters.h"
#include "GUINode.h"

class UINode;

class ParameterData {
public:
   
   GtkWidget *optionmenu;
   GtkWidget *optionmenu_menu;
   GtkWidget *combo_entry;
   GtkWidget *entry;
   GtkWidget *label;

};


class GUINodeParameters {
protected:
   GtkWidget *nodeproperty;
   UINodeParameters *nodeParams;
   vector<ParameterData> params;
   vector<ParameterText *> &textParams;
   GUINode *node;
   GtkWidget *text_comments;
   GtkWidget *list1;
   GtkWidget *list2;
   GtkWidget *input_entry, *output_entry;
   GtkWidget *inputSelect, *outputSelect;
public:
   GUINodeParameters(GUINode *_node, string type, UINodeParameters *_nodeParams);
   ~GUINodeParameters();
   void show();
   void hide();
   void apply();
   void changed();
   void insertNetParams(vector<string> &par);
   ParameterData *getParamDataNamed(string n);
   void insertLoadedParam(ParameterText *param, string type, string value);
   GUINode *getGUINode() {return node;}
   void addInput();
   void addOutput();
   void removeInput();
   void removeOutput();
   void setInputSelect(GtkWidget *w) {inputSelect=w;}
   void setOutputSelect(GtkWidget *w) {outputSelect=w;}
   void unsetInputSelect(GtkWidget *w) {if (inputSelect==w) inputSelect=NULL;}
   void unsetOutputSelect(GtkWidget *w) {if (outputSelect==w) outputSelect=NULL;}
};


#endif
